<?php
namespace Teknisa\EST\Modules\EstoqueCego\Controllers;

use Teknisa\EST\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;

class Est91000ProgramacaoDoInventarioCegoController extends TeknisaCrud {

    protected $dataSourceName = "inventestcego_paramfilial_paramgeral_filioper";
    protected $parameterBagColumns = ["CDFILIAL","DTINICIAL","DTFINAL","IDSITESTCEGO","CDOPERADOR"];

    protected $Est91000ProgramacaoDoInventarioCegoService;
    protected $connection;
    
    public function __construct($crudService,$parameterBag, $Est91000Service, $entityManager) {
        parent::__construct($crudService,$parameterBag);

        $this->Est91000ProgramacaoDoInventarioCegoService = $Est91000Service;
        $this->connection = $entityManager->getConnection();
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $conditions = $request->getFilterCriteria()->getConditions();
        
        $this->Est91000ProgramacaoDoInventarioCegoService->formatMutipleFilialCode($conditions);
        
        $newFilterCriteria = new FilterCriteria($this->dataSourceName, $conditions);
        $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        
        parent::find($filter, $response);
    }
    
    public function saveProducts(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            $this->Est91000ProgramacaoDoInventarioCegoService->insertLote($row);
            $this->Est91000ProgramacaoDoInventarioCegoService->saveProducts($row);
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}
