<?php
namespace Teknisa\EST\Modules\EstoqueCego\Factories;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Est91000ProgramacaoDoInventarioCegoFactory {
    protected $connection;
    protected $entityManager;

    public function __construct ($entityManager) {
        $this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
    }
    
    public function insertLote($params) {
        $sql = "INSERT INTO LOTE
                (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
                (SELECT :CDFILIAL CDFILIAL, :NRLOTEESTQ NRLOTEESTQ, :NRSUBLOTE NRSUBLOTE, :CDPRODUTO CDPRODUTO,
                'L' IDSTATLOTE, SYSDATE DTENTRLOTE
                FROM PARAMGERAL
                MINUS
                SELECT CDFILIAL, NRLOTEESTQ, NRSUBLOTE, :CDPRODUTO CDPRODUTO, 'L', SYSDATE
                FROM LOTE
                WHERE :CDFILIAL   =  CDFILIAL     AND
                      :NRLOTEESTQ =  NRLOTEESTQ   AND
                      :NRSUBLOTE  =  NRSUBLOTE    AND
                      :CDPRODUTO  =  CDPRODUTO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveProducts($params) {
        $sql = "INSERT INTO ITEMINVENTCEGO
                  (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DTCONTAGEM, NRLOTEESTQ, NRSUBLOTE,
                   CDPRODUTO, QTINVENTESTCEGO, IDGERITINVCEGPR)
                VALUES
                  (:CDFILIAL, :CDALMOXARIFE, :CDLOCALESTOQ, :DTCONTAGEM, :NRLOTEESTQ, :NRSUBLOTE,
                   :CDPRODUTO, :QTINVENTESTCEGO, :IDGERITINVCEGPR)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}