<?php
namespace Teknisa\EST\Modules\EstoqueCego\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Est91000ProgramacaoDoInventarioCegoService {
    
    protected $Est91000ProgramacaoDoInventarioCegoFactory;
    protected $dataSourceManager;
    
    public function __construct($Est91000factory, $environment,$dataSourceManager) {
        $this->Est91000ProgramacaoDoInventarioCegoFactory = $Est91000factory;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
    }
    
    public function formatMutipleFilialCode (&$conditions){
        
        foreach($conditions as &$condition){
            if($condition['columnName'] = 'CDFILIAL'){
                $newCondition = join("_",$condition['value']);
                $condition['value'] = "_" . $newCondition . "_";;
                break;
            }
        }
    }
    
    public function insertLote ($row){
        $params = array(
            ":CDFILIAL" => $row['CDFILIAL'],
            ":NRLOTEESTQ" => $row['NRLOTEESTQ'],
            ":NRSUBLOTE" => $row['NRSUBLOTE'],
            ":CDPRODUTO"   => $row['CDPRODUTO']
        );
        $this->Est91000ProgramacaoDoInventarioCegoFactory->insertLote($params);
    }
    
    public function saveProducts ($row){
        $params = array(
            ":CDFILIAL" => $row['CDFILIAL'],
            ":CDALMOXARIFE" => $row['CDALMOXARIFE'],
            ":CDLOCALESTOQ" => $row['CDLOCALESTOQ'],
            ":DTCONTAGEM" => $row['DTCONTAGEM'],
            ":NRLOTEESTQ" => $row['NRLOTEESTQ'],
            ":NRSUBLOTE" => $row['NRSUBLOTE'],
            ":CDPRODUTO" => $row['CDPRODUTO'],
            ":QTINVENTESTCEGO" => $row['QTINVENTESTCEGO'],
            ":IDGERITINVCEGPR" => $row['IDGERITINVCEGPR']
        );
        $this->Est91000ProgramacaoDoInventarioCegoFactory->saveProducts($params);
    }
    
}
